api_endpoints = {
    "short_interest": "https://www.fudstop.io/api/short_interest?ticker={ticker}",
    "balance_sheet": "https://www.fudstop.io/api/balance_sheet?ticker={ticker}&limit=1",
    "cash_flow": "https://www.fudstop.io/api/cash_flow?ticker={ticker}&limit=1",
    "income_statement": "https://www.fudstop.io/api/income_statement?ticker={ticker}&limit=5",
    "analysts": "https://www.fudstop.io/api/analysts?ticker={ticker}",
    "volume_analysis": "https://www.fudstop.io/api/volume_analysis?ticker={ticker}",
    "deals": "https://www.fudstop.io/api/deals?ticker={ticker}",
    "company_info": "https://www.fudstop.io/api/company_info?ticker={ticker}",
    "cost_distribution": "https://www.fudstop.io/api/cost_distribution?ticker={ticker}&start_date={start_date}&end_date={end_date}",
    "news": "https://www.fudstop.io/api/news?ticker={ticker}",
    "order_flow": "https://www.fudstop.io/api/order_flow?ticker={ticker}&count=800",
    "etf_holdings": "https://www.fudstop.io/api/etf_holdings?ticker={ticker}&pageSize=5",
    "institutional": "https://www.fudstop.io/api/institutional?ticker={ticker}",
    "insiders": "https://www.fudstop.io/api/insiders?limit=25",
    "news_sentiments": "https://www.fudstop.io/api/news_sentiments?tickers={ticker}",
    'news_sentiment': "https://www.fudstop.io/api/news_sentiment?ticker={ticker}",
    "point_of_control": "https://www.fudstop.io/api/point_of_control?ticker={ticker}",
    "major_holdings": "https://www.fudstop.io/api/major_holdings?ticker={ticker}",
    "mutual_fund_holdings": "https://www.fudstop.io/api/mutual_fund_holdings?ticker={ticker}",
    "institutional_holdings": "https://www.fudstop.io/api/institutional_holdings?ticker={ticker}",
    "executive_holdings": "https://www.fudstop.io/api/executive_holdings?ticker={ticker}",
    "insider_purchases": "https://www.fudstop.io/api/insider_purchases?ticker={ticker}",
    "insider_transactions": "https://www.fudstop.io/api/insider_transactions?ticker={ticker}",
    "all_options": "https://www.fudstop.io/api/all_options?ticker={ticker}&strike_gte=&strike_lte=&expiry_gte=&expiry_lte=",
    "historic_options": "https://www.fudstop.io/api/historic_options?ticker={ticker}",
    "atm_statistics": "https://www.fudstop.io/api/atm_statistics?ticker={ticker}",
    "options_sentiment": "https://www.fudstop.io/api/options_sentiment?ticker={ticker}",
    "volatile_rank": "https://www.fudstop.io/api/volatile_rank?ticker={ticker}",
    "iv_percentile": "https://www.fudstop.io/api/iv_percentile?ticker={ticker}",
    "highest_oi": "https://www.fudstop.io/api/highest_oi?ticker={ticker}",
    "stock_info": "https://www.fudstop.io/api/stock_info?ticker={ticker}",
    "options_monitor": "https://www.fudstop.io/api/options_monitor?ticker={ticker}",
    "historic_ivx": "https://www.fudstop.io/api/historic_ivx?ticker={ticker}",
    "volatility_snapshot": "https://www.fudstop.io/api/volatility_snapshot?ticker={ticker}",
    "volatility_scale": "https://www.fudstop.io/api/volatility_scale?ticker={ticker}",
    "recent_submissions": "https://www.fudstop.io/api/recent_submissions?ticker={ticker}",
    "form_4": "https://www.fudstop.io/api/form_4?ticker={ticker}",
    "sec_filings": "https://www.fudstop.io/api/sec_filings?ticker={ticker}",
    "eps_trends": "https://www.fudstop.io/api/eps_trends?ticker={ticker}",
    "eps_revisions": "https://www.fudstop.io/api/eps_revisions?ticker={ticker}",
    "growth_estimate": "https://www.fudstop.io/api/growth_estimate?ticker={ticker}",
    "earnings_estimate": "https://www.fudstop.io/api/earnings_estimate?ticker={ticker}",
    "revenue_estimate": "https://www.fudstop.io/api/revenue_estimate?ticker={ticker}",
    "top_options": "https://www.fudstop.io/api/top_options?type={rank_type}",
    "top_losers": "https://www.fudstop.io/api/top_losers?type={rank_type}",
    "top_gainers": "https://www.fudstop.io/api/top_gainers?type={rank_type}",
    "all_etfs": "https://www.fudstop.io/api/all_etfs?types={type}",
    "highs_and_lows": "https://www.fudstop.io/api/highs_and_lows?type={type}",
    "ipos": "https://www.fudstop.io/api/ipos?type={type}",
    "industry_data": "https://www.fudstop.io/api/industry_data?",
    "marketable_securities": "https://www.fudstop.io/api/marketable_securities?",
    "fed_distribution": "https://www.fudstop.io/api/fed_distribution?",
    "estimated_ownership": "https://www.fudstop.io/api/estimated_ownership?",
    "circulation": "https://www.fudstop.io/api/circulation?",
    "daily_treasury": "https://www.fudstop.io/api/daily_treasury?",
    "public_debt": "https://www.fudstop.io/api/public_debt?",
    "debt_subject_to_limit": "https://www.fudstop.io/api/debt_subject_to_limit?",
    "refunds_issued": "https://www.fudstop.io/api/refunds_issued?",
    "treasury_amount": "https://www.fudstop.io/api/treasury_amount?",
    "record_setting_auctions": "https://www.fudstop.io/api/record_setting_auctions?",
    "debt_to_penny": "https://www.fudstop.io/api/debt_to_penny?",
    "federal_reserve_notes": "https://www.fudstop.io/api/federal_reserve_notes?",
    "upcoming_auctions": "https://www.fudstop.io/api/upcoming_auctions?",
    "treasury_gold": "https://www.fudstop.io/api/treasury_gold?",
    "earnings_today": "https://www.fudstop.io/api/earnings_today",
    "earnings_tomorrow": "https://www.fudstop.io/api/earnings_tomorrow",
    "calendar": "https://www.fudstop.io/api/calendar",
    "agency_mbs": "https://www.fudstop.io/api/agency_mbs?last={last}",
    "central_bank_liquidity_swaps": "https://www.fudstop.io/api/central_bank_liquidity_swaps",
    "guide_sheets": "https://www.fudstop.io/api/guide_sheets",
    "counterparties": "https://www.fudstop.io/api/counterparties",
    "soma": "https://www.fudstop.io/api/soma",
    "liquidity_swaps": "https://www.fudstop.io/api/liquidity_swaps?last={last}",
    "fed_market_share": "https://www.fudstop.io/api/fed_market_share",
    "reference_rates": "https://www.fudstop.io/api/reference_rates?type={type}",
    "reverse_repo": "https://www.fudstop.io/api/reverse_repo",
    "securities_lending": "https://www.fudstop.io/api/securities_lending?start_date={start_date}&end_date={end_date}",
    "sponsored_repo": "https://www.fudstop.io/api/sponsored_repo",
    "sponsored_reverse_repo": "https://www.fudstop.io/api/sponsored_reverse_repo",
    "monthly_data": "https://www.fudstop.io/api/monthly_data?tier={tier}&start_date={start_date}",
    "ats_summary": "https://www.fudstop.io/api/ats_summary?tier={tier}&start_date={start_date}",
    "ticker_ats": "https://www.fudstop.io/api/ticker_ats?ticker={ticker}&start_date={start_date}",
    "pe_scan": "https://www.fudstop.io/api/pe_scan",
    "fifty_high": "https://www.fudstop.io/api/fifty_high",
    "fifty_low": "https://www.fudstop.io/api/fifty_low",
    "underlying_volume_check": "https://www.fudstop.io/api/underlying_volume_check",
    "top_volatile": "https://www.fudstop.io/api/top_volatile",
    "most_active_options": "https://www.fudstop.io/api/most_active_options",
    "earnings": "https://www.fudstop.io/api/earnings",
    "curated_options": "https://www.fudstop.io/api/curated_options?ticker={ticker}&expiry_date={expiry_date}",
    "pe_diff_bullish": "https://www.fudstop.io/api/pe_diff_bullish",
    "pe_diff_bearish": "https://www.fudstop.io/api/pe_diff_bearish",
    "vol_anal_sentiment": "https://www.fudstop.io/api/vol_anal_sentiment",
    "cost_sentiment": "https://www.fudstop.io/api/cost_sentiment",
    "all_highest_oi": "https://www.fudstop.io/api/all_highest_oi?tickers={tickers}",
    "td_count": "https://www.fudstop.io/api/td_count?ticker={ticker}",
    "analyst_price_targets": "https://www.fudstop.io/api/analyst_price_targets?ticker={ticker}",
    "recommendations": "https://www.fudstop.io/api/recommendations?ticker={ticker}",
    "rsi": "https://www.fudstop.io/api/rsi?ticker={ticker}",
    "multi_quote": "https://www.fudstop.io/api/multi_quote?tickers={tickers}",
    "capital_flow": "https://www.fudstop.io/api/capital_flow?ticker={ticker}",
    "stock_loans": "https://www.fudstop.io/api/stock_loans?report_date={report_date}&type={type}",
    "today_most_active": "https://www.fudstop.io/api/today_most_active",
    "open_interest": "https://www.fudstop.io/api/open_interest",
    "probability": "https://www.fudstop.io/api/probability?ticker={ticker}&vola_type={vola_type}&term={term}",
    "volume_totals": "https://www.fudstop.io/api/volume_totals",
    "volatility_scale_chart": "https://www.fudstop.io/api/volatility_scale_chart?ticker={ticker}",
    "stock_monitor": "https://www.fudstop.io/api/stock_monitor",
    "underlying_beta": "https://www.fudstop.io/api/underlying_beta?ticker={ticker}",
    "underlying_iv_percentile": "https://www.fudstop.io/api/underlying_iv_percentile?ticker={ticker}",
    "underlying_iv_rank": "https://www.fudstop.io/api/underlying_iv_rank?ticker={ticker}",
    "underlying_ivx": "https://www.fudstop.io/api/underlying_ivx?ticker={ticker}",
    "underlying_ivx_change": "https://www.fudstop.io/api/underlying_ivx_change?ticker={ticker}",
    "econ_events": "https://www.fudstop.io/api/events",
    "econ_indicators": "https://www.fudstop.io/api/econ_indicators",
    "underlying_ivx_change_open": "https://www.fudstop.io/api/underlying_ivx_change_open?ticker={ticker}",
    "underlying_ivx_change_percent": "https://www.fudstop.io/api/underlying_ivx_change_percent?ticker={ticker}",
    "underlying_ivx_change_percent_open": "https://www.fudstop.io/api/underlying_ivx_change_percent_open?ticker={ticker}",
    "flex_reports": "https://www.fudstop.io/api/flex_reports?date={date}",
    "options_screener": """https://www.fudstop.io/api/options_screener?volume_gte={volume_gte}&volume_lte={volume_lte}&impl_vol_gte={impl_vol_gte}&impl_vol_lte={impl_vol_lte}&leverage_ratio_gte={leverage_ratio_gte}&leverage_ratio_lte={leverage_ratio_lte}&prob_itm_gte={prob_itm_gte}&prob_itm_lte={prob_itm_lte}&rho_gte={rho_gte}&rho_lte={rho_lte}&gamma_gte={gamma_gte}&gamma_lte={gamma_lte}&delta_gte={delta_gte}&delta_lte={delta_lte}&his_volatility_gte={his_volatility_gte}&his_volatility_lte={his_volatility_lte}&open_interest_gte={open_interest_gte}&open_interest_lte={open_interest_lte}&total_volume_gte={total_volume_gte}&total_volume_lte={total_volume_lte}&theta_gte={theta_gte}&theta_lte={theta_lte}&vega_gte={vega_gte}&vega_lte={vega_lte}&change_ratio_gte={change_ratio_gte}&change_ratio_lte={change_ratio_lte}&pulse_index_gte={pulse_index_gte}&pulse_index_lte={pulse_index_lte}&bid_gte={bid_gte}&bid_lte={bid_lte}&ask_gte={ask_gte}&ask_lte={ask_lte}&iv_percent_gte={iv_percent_gte}&iv_percent_lte={iv_percent_lte}&total_open_interest_gte={total_open_interest_gte}&total_open_interest_lte={total_open_interest_lte}&expire_date_gte={expire_date_gte}&expire_date_lte={expire_date_lte}""",
    "option_dips": "https://www.fudstop.io/api/option_dips",
    "micro": "https://www.fudstop.io/api/micro?abbreviation={abbreviation}",
    "metal": "https://www.fudstop.io/api/metal?abbreviation={abbreviation}",
    "energy": "https://www.fudstop.io/api/energy?abbreviation={abbreviation}",
    "agricultural": "https://www.fudstop.io/api/aggricultural?abbreviation={abbreviation}",
    "equity_index": "https://www.fudstop.io/api/equity_index?abbreviation={abbreviation}",
    "fx": "https://www.fudstop.io/api/fx?abbreviation={abbreviation}",
    "crypto_futures": "https://www.fudstop.io/api/crypto_futures?abbreviation={abbreviation}",
    "interest_rate": "https://www.fudstop.io/api/interest_rate?abbreviation={abbreviation}",
    
    }
